diff --git a/src/interfaces/libpq/fe-secure-openssl.c b/src/interfaces/libpq/fe-secure-openssl.c
index c7651c98ab5..54710c13c23 100644
--- a/src/interfaces/libpq/fe-secure-openssl.c
+++ b/src/interfaces/libpq/fe-secure-openssl.c
@@ -386,15 +386,9 @@ pgtls_get_peer_certificate_hash(PGconn *conn, size_t *len)
 
 	/*
 	 * Get the signature algorithm of the certificate to determine the hash
-	 * algorithm to use for the result.  Prefer X509_get_signature_info(),
-	 * introduced in OpenSSL 1.1.1, which can handle RSA-PSS signatures.
+	 * algorithm to use for the result.
 	 */
-#if HAVE_X509_GET_SIGNATURE_INFO
 	if (!X509_get_signature_info(peer_cert, &algo_nid, NULL, NULL, NULL))
-#else
-	if (!OBJ_find_sigid_algs(X509_get_signature_nid(peer_cert),
-							 &algo_nid, NULL))
-#endif
 	{
 		libpq_append_conn_error(conn, "could not determine server certificate signature algorithm");
 		return NULL;
@@ -463,7 +457,6 @@ verify_cb(int ok, X509_STORE_CTX *ctx)
 	return ok;
 }
 
-#ifdef HAVE_SSL_CTX_SET_CERT_CB
 /*
  * Certificate selection callback
  *
@@ -490,7 +483,6 @@ cert_cb(SSL *ssl, void *arg)
 	 */
 	return 1;
 }
-#endif
 
 /*
  * OpenSSL-specific wrapper around
@@ -717,14 +709,11 @@ pgtls_verify_peer_name_matches_certificate_guts(PGconn *conn,
 /* See pqcomm.h comments on OpenSSL implementation of ALPN (RFC 7301) */
 static unsigned char alpn_protos[] = PG_ALPN_PROTOCOL_VECTOR;
 
-#ifdef HAVE_SSL_CTX_SET_KEYLOG_CALLBACK
 /*
  * SSL Key Logging callback
  *
  * This callback lets the user store all key material to a file for debugging
- * purposes.  The file will be written using the NSS keylog format.  LibreSSL
- * 3.5 introduced stub function to set the callback for OpenSSL compatibility
- * but the callback is never invoked.
+ * purposes.  The file will be written using the NSS keylog format.
  *
  * Error messages added to the connection object won't be printed anywhere if
  * the connection is successful.  Errors in processing keylogging are printed
@@ -759,7 +748,6 @@ SSL_CTX_keylog_cb(const SSL *ssl, const char *line)
 	(void) rc;					/* silence compiler warnings */
 	close(fd);
 }
-#endif
 
 /*
  *	Create per-connection SSL object, and load the client certificate,
@@ -829,10 +817,8 @@ initialize_SSL(PGconn *conn)
 		SSL_CTX_set_default_passwd_cb_userdata(SSL_context, conn);
 	}
 
-#ifdef HAVE_SSL_CTX_SET_CERT_CB
 	/* Set up a certificate selection callback. */
 	SSL_CTX_set_cert_cb(SSL_context, cert_cb, conn);
-#endif
 
 	/* Disable old protocol versions */
 	SSL_CTX_set_options(SSL_context, SSL_OP_NO_SSLv2 | SSL_OP_NO_SSLv3);
@@ -1085,12 +1071,8 @@ initialize_SSL(PGconn *conn)
 	{
 #ifdef HAVE_SSL_CTX_SET_KEYLOG_CALLBACK
 		SSL_CTX_set_keylog_callback(SSL_context, SSL_CTX_keylog_cb);
-#else
-#ifdef LIBRESSL_VERSION_NUMBER
-		fprintf(stderr, libpq_gettext("WARNING: sslkeylogfile support requires OpenSSL\n"));
 #else
 		fprintf(stderr, libpq_gettext("WARNING: libpq was not built with sslkeylogfile support\n"));
-#endif
 #endif
 	}
 
diff --git a/src/interfaces/libpq/fe-secure.c b/src/interfaces/libpq/fe-secure.c
index 1a8e2e6746e..52e4f92b980 100644
--- a/src/interfaces/libpq/fe-secure.c
+++ b/src/interfaces/libpq/fe-secure.c
@@ -473,14 +473,11 @@ PQsslAttributeNames(PGconn *conn)
 
 	return result;
 }
-#endif							/* USE_SSL */
 
 /*
  * Dummy versions of OpenSSL key password hook functions, when built without
- * OpenSSL.
+ * SSL.
  */
-#ifndef USE_OPENSSL
-
 PQsslKeyPassHook_OpenSSL_type
 PQgetSSLKeyPassHook_OpenSSL(void)
 {
@@ -498,7 +495,7 @@ PQdefaultSSLKeyPassHook_OpenSSL(char *buf, int size, PGconn *conn)
 {
 	return 0;
 }
-#endif							/* USE_OPENSSL */
+#endif							/* USE_SSL */
 
 /* Dummy version of GSSAPI information functions, when built without GSS support */
 #ifndef ENABLE_GSS
diff --git a/src/interfaces/libpq/libpq-int.h b/src/interfaces/libpq/libpq-int.h
index 3f921207a14..06276db377b 100644
--- a/src/interfaces/libpq/libpq-int.h
+++ b/src/interfaces/libpq/libpq-int.h
@@ -66,10 +66,12 @@ typedef struct
 #endif
 #endif							/* ENABLE_SSPI */
 
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 #include <openssl/ssl.h>
 #include <openssl/err.h>
+#endif							/* USE_OPENSSL, USE_LIBRESSL */
 
+#ifdef USE_OPENSSL
 #ifndef OPENSSL_NO_ENGINE
 #define USE_SSL_ENGINE
 #endif
@@ -627,7 +629,7 @@ struct pg_conn
 	bool		last_read_was_eof;
 
 #ifdef USE_SSL
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 	SSL		   *ssl;			/* SSL status, if have SSL connection */
 	X509	   *peer;			/* X509 cert of server */
 #ifdef USE_SSL_ENGINE
@@ -636,7 +638,7 @@ struct pg_conn
 	void	   *engine;			/* dummy field to keep struct the same if
 								 * OpenSSL version changes */
 #endif
-#endif							/* USE_OPENSSL */
+#endif							/* USE_OPENSSL, USE_LIBRESSL */
 #endif							/* USE_SSL */
 
 #ifdef ENABLE_GSS
diff --git a/src/interfaces/libpq/meson.build b/src/interfaces/libpq/meson.build
index b0ae72167a1..410a2d94a3f 100644
--- a/src/interfaces/libpq/meson.build
+++ b/src/interfaces/libpq/meson.build
@@ -28,7 +28,11 @@ endif
 
 if ssl.found()
   libpq_sources += files('fe-secure-common.c')
-  libpq_sources += files('fe-secure-openssl.c')
+  if ssl_library == 'openssl'
+    libpq_sources += files('fe-secure-openssl.c')
+  else
+    libpq_sources += files('fe-secure-libressl.c')
+  endif
 endif
 
 if gssapi.found()
diff --git a/src/port/pg_strong_random.c b/src/port/pg_strong_random.c
index c8d8a70d896..a1bf57b808a 100644
--- a/src/port/pg_strong_random.c
+++ b/src/port/pg_strong_random.c
@@ -50,7 +50,7 @@
 
 
 
-#ifdef USE_OPENSSL
+#if defined(USE_OPENSSL) || defined(USE_LIBRESSL)
 
 #include <openssl/rand.h>
 
@@ -134,7 +134,7 @@ pg_strong_random(void *buf, size_t len)
 	return false;
 }
 
-#else							/* not USE_OPENSSL or WIN32 */
+#else							/* not USE_OPENSSL, USE_LIBRESSL or WIN32 */
 
 /*
  * Without OpenSSL or Win32 support, just read /dev/urandom ourselves.
diff --git a/src/test/ssl/t/001_ssltests.pl b/src/test/ssl/t/001_ssltests.pl
index cb7c2a06193..ea38e5dd407 100644
--- a/src/test/ssl/t/001_ssltests.pl
+++ b/src/test/ssl/t/001_ssltests.pl
@@ -13,9 +13,9 @@ use lib $FindBin::RealBin;
 
 use SSL::Server;
 
-if ($ENV{with_ssl} ne 'openssl')
+if ($ENV{with_ssl} ne 'openssl' && $ENV{with_ssl} ne 'libressl')
 {
-	plan skip_all => 'OpenSSL not supported by this build';
+	plan skip_all => 'SSL not supported by this build';
 }
 if (!$ENV{PG_TEST_EXTRA} || $ENV{PG_TEST_EXTRA} !~ /\bssl\b/)
 {
diff --git a/src/test/ssl/t/002_scram.pl b/src/test/ssl/t/002_scram.pl
index 88c82a4ac11..b9fb400f58b 100644
--- a/src/test/ssl/t/002_scram.pl
+++ b/src/test/ssl/t/002_scram.pl
@@ -16,9 +16,9 @@ use lib $FindBin::RealBin;
 
 use SSL::Server;
 
-if ($ENV{with_ssl} ne 'openssl')
+if ($ENV{with_ssl} ne 'openssl' && $ENV{with_ssl} ne 'libressl')
 {
-	plan skip_all => 'OpenSSL not supported by this build';
+	plan skip_all => 'SSL not supported by this build';
 }
 if (!$ENV{PG_TEST_EXTRA} || $ENV{PG_TEST_EXTRA} !~ /\bssl\b/)
 {
diff --git a/src/test/ssl/t/003_sslinfo.pl b/src/test/ssl/t/003_sslinfo.pl
index 56d32cbaa31..19f4277d0ad 100644
--- a/src/test/ssl/t/003_sslinfo.pl
+++ b/src/test/ssl/t/003_sslinfo.pl
@@ -14,9 +14,9 @@ use lib $FindBin::RealBin;
 
 use SSL::Server;
 
-if ($ENV{with_ssl} ne 'openssl')
+if ($ENV{with_ssl} ne 'openssl' && $ENV{with_ssl} ne 'libressl')
 {
-	plan skip_all => 'OpenSSL not supported by this build';
+	plan skip_all => 'SSL not supported by this build';
 }
 if (!$ENV{PG_TEST_EXTRA} || $ENV{PG_TEST_EXTRA} !~ /\bssl\b/)
 {
diff --git a/src/test/ssl/t/004_sni.pl b/src/test/ssl/t/004_sni.pl
index f1a135bb3c8..625d863b217 100644
--- a/src/test/ssl/t/004_sni.pl
+++ b/src/test/ssl/t/004_sni.pl
@@ -20,6 +20,11 @@ my $SERVERHOSTADDR = '127.0.0.1';
 # This is the pattern to use in pg_hba.conf to match incoming connections.
 my $SERVERHOSTCIDR = '127.0.0.1/32';
 
+if ($ENV{with_ssl} eq 'libressl')
+{
+	plan skip_all => 'SNI not supported when building with LibreSSL';
+}
+
 if ($ENV{with_ssl} ne 'openssl')
 {
 	plan skip_all => 'OpenSSL not supported by this build';
@@ -32,12 +37,6 @@ if (!$ENV{PG_TEST_EXTRA} || $ENV{PG_TEST_EXTRA} !~ /\bssl\b/)
 }
 
 my $ssl_server = SSL::Server->new();
-
-if ($ssl_server->is_libressl)
-{
-	plan skip_all => 'SNI not supported when building with LibreSSL';
-}
-
 my $node = PostgreSQL::Test::Cluster->new('primary');
 $node->init;
 
diff --git a/src/test/ssl/t/SSL/Backend/OpenSSL.pm b/src/test/ssl/t/SSL/Backend/OpenSSL.pm
index 6060771c1a8..826e6116eca 100644
--- a/src/test/ssl/t/SSL/Backend/OpenSSL.pm
+++ b/src/test/ssl/t/SSL/Backend/OpenSSL.pm
@@ -213,6 +213,8 @@ sub get_library
 {
 	my ($self) = @_;
 
+	# XXX: Temporary hack during initial discussions of the patch
+	return 'LibreSSL' if (library_is_libressl());
 	return $self->{_library};
 }
 
@@ -230,7 +232,7 @@ sub library_is_libressl
 
 	# The HAVE_SSL_CTX_SET_CERT_CB macro isn't defined for LibreSSL.
 	# We may eventually need a less-bogus heuristic.
-	return not check_pg_config("#define HAVE_SSL_CTX_SET_CERT_CB 1");
+	return check_pg_config("#define HAVE_SSL_CTX_USE_CERTIFICATE_CHAIN_MEM 1");
 }
 
 # Internal method for copying a set of files, taking into account wildcards
diff --git a/src/test/ssl/t/SSL/Server.pm b/src/test/ssl/t/SSL/Server.pm
index 4400a432f42..faef4b51dde 100644
--- a/src/test/ssl/t/SSL/Server.pm
+++ b/src/test/ssl/t/SSL/Server.pm
@@ -103,6 +103,11 @@ sub new
 		$self->{flavor} = 'openssl';
 		$self->{backend} = SSL::Backend::OpenSSL->new();
 	}
+	elsif ($flavor =~ /\Alibressl\z/i)
+	{
+		$self->{flavor} = 'libressl';
+		$self->{backend} = SSL::Backend::OpenSSL->new();
+	}
 	else
 	{
 		die "SSL flavor $flavor unknown";
-- 
2.39.3 (Apple Git-146)

